### TRAP GENERATED COMPILER FRAME MODULE - DO NOT EDIT ###
# GLOBALS
import string, types

IRTypeError="IRTypeError" # exception


_TRAP_indent=0 # initial indentation to be used by __repr__
_TRAP_lb=None  # handle to line buffer used in __repr__

# line-oriented output: create buffer, append string, append newline,
# in/dedent
class _TRAP_LBUF:
  def __init__(self, outerind=None):
    # create an initial line buffer, only containing initial indentation
    global _TRAP_indent
    import re
    self.patt_whitespc = re.compile(r'[ 	]*')
    if outerind: self.Nindent=outerind
    else:        self.Nindent=_TRAP_indent
    self.cont=" "*self.Nindent
  def append(self, string): # append a (code) string to last line
    # if you append a comment ' ... # ....', you HAVE TO call self.nl()
    # immediately afterwards
    self.cont=self.cont+string
  def nl(self): # start new line
    # but suppress repeated newlines, i.e. insert newline only
    # if current line is not just whitespace)
    if self._lastwhite() == -1: # not just whitespace
      self.append("\n"+(' '*self.Nindent))
  def _lastwhite(self):
    # test whether last line consists of whitespace only
    # if so, return begin position of last line in self.cont
    # otherwise return -1
    # get tail of buffer
    beglast=string.rfind(self.cont, '\n')+1 # (0 if not found, pos+1 else)
    tail=self.cont[beglast:] # last or only line
    mo=self.patt_whitespc.search(tail)
    if mo:
      if mo.end()==len(tail): # all whitespace
        return beglast
    return -1
  def _adjustlastwhite(self):
    # adjust trailing whitespace (if any) to new indentation
    p=self._lastwhite()
    if p!=-1: self.cont=self.cont[:p]+(' '*self.Nindent)
    
  # calling indent/dedent does NOT imply nl(); just the indentation
  # state and the actual amount of trailing whitespace in the buffer,
  # if any, are updated
  def indent(self):
    self.Nindent=self.Nindent+4
    self._adjustlastwhite()

  def dedent(self):
    self.Nindent=self.Nindent-4
    self._adjustlastwhite()

def _TRAP_joinfields(l, sep):
  # get rid of leading empty strings
  # to prevent string.joinfields to insert leading
  # spaces/separators for them
  l2=l[:] # copy
  while l2 and l2[0]=="": del l2[0]
  return string.joinfields(l2, sep)

def _TRAP_quote(str):
    if '"' in str:
      return "'"+str+"'"
    return '"'+str+'"'
  
def _TRAP_typecheck(fieldtype, colctype, data, context):
      # check wheter a given object reference conforms 
      # to the type constraint expressed by strings fieldtype
      # (name of domain or any Python basic type or ""=ANY) and/or 
      # colctype (type of collection: "{" "[" "(" ""=NoCollection)
      # Raise IRTypeError if not.
      global IRTypeError
      if isinstance(data, _TRAP_joker): return    # joker is always allowed
      if data==None: return # None is always allowed, too
      # print "TYPE: ", repr(fieldtype), "/", repr(colctype), "DATA:", repr(data)
      try:
        if colctype:
           # list/tuple/dictionary (collection type)
           if colctype=='[':
              if type(data)!=type([]):
                raise IRTypeError, "[list]"
           if colctype=='(':
              if type(data)!=type(()):
                raise IRTypeError, "(tuple)"
           if colctype=="{":
              if type(data)!=type({}):
                raise IRTypeError, "{dictionary}"
           if fieldtype and colctype!="{":
              # check elements of sequence, recursively
              # no in-depth checking for dicts 
              count=0
              for d in data:
                _TRAP_typecheck(fieldtype, "", d, context+"["+str(count)+"]")
                count=count+1
           return
        if fieldtype: # elementary type
          if fieldtype=="StringType":
            if type(data)!=type(""):
                raise IRTypeError, "StringType"
          elif fieldtype=="IntType":
            if type(data)!=type(42):
                raise IRTypeError, "IntType"
          elif fieldtype=="FloatType":
            if type(data)!=type(42.0):
                raise IRTypeError, "FloatType"
          else: # non-simple type, i.e., IR class type
            classobj=eval(fieldtype)
            if not isinstance(data, classobj):
                raise IRTypeError, "domain class '"+fieldtype+"'"
      except IRTypeError, formal:
        raise IRTypeError, context+" violates type constraint.\n Formal type: "+formal+"\n Actual type: "+str(type(data))+", String representation of object: '"+str(data)+"'"
  

# IR ABSTRACT ROOT DOMAIN SUPERCLASS ...
class REF: 
  fields=[]
  fieldtypes={} # will be overridden in node classes

  def __repr__(self): # general IR-to-text function (public entry point)
  # output format = Python constructor syntax, including line breaks & indentation
  # This is largely an "initializing wrapper" for _TRAPrepr below, which does the actual dirty work of
  # node printing. _TRAPrepr in turn relies on _TRAPrepr_field to process the individual
  # fields of the node.
  # The "printing", and the indentation handling in particular works as follows:
  # - both methods "print" to a dedicated, internal "line buffer" (a _TRAP_LBUF instance
  #   to which global variable _TRAP_lb is a handle)
  # - the line buffer has methods to modify the indentation state, a method for appending
  #   text to the current line, and a method for opening a newline including its indentation whitespace
  # - both _TRAPrepr and _TRAPrepr_field try to output "one-liners" and "suites", depending
  #   on how many elements there are to "print".
  # - Each of these methods sets the indentation state correctly during its execution
  #   (even for one-element jobs as they can recursively contain "suites")
  #   and, for multi-element jobs, inserts line breaks to output "suites".

      global _TRAP_lb
      # __repr__ had to be made re-entrant since recursive calls occur when node fields have
      # no type information, i.e. type ANY
      save_lb=_TRAP_lb # reentrance the hard way: private buffer per __repr__ incarnation
      if _TRAP_lb: # there is a surrounding incarnation - respect indent
         _TRAP_lb=_TRAP_LBUF(save_lb.Nindent)
      else: # use default indentation   
         _TRAP_lb=_TRAP_LBUF() 
      self._TRAPrepr()      # "print" to buffer
      res=_TRAP_lb.cont     # save the result
      _TRAP_lb=save_lb # restore old buffer, if any, to proceed with surrounding incarnation
      return res

  def _TRAPrepr(self): 
      global _TRAP_lb  # output line buffer
      tlb=_TRAP_lb     # shortcut
      # class name and opening brace
      tlb.append(self.__class__.__name__+"(")
      tlb.indent()
      # fields (comma-separated) using _TRAPrepr_field()
      count=len(self.fields)
      if count<=1: # one-liner
        if count==1:
          name=self.fields[0]
          (tag, eltype, coltype)=self.fieldtypes[name]
          self._TRAPrepr_field(self.__dict__[name], eltype, coltype, name)
        tlb.dedent()  
        tlb.append(")")
        return
      # otherwise: multi-line field 'suite'
      for name in self.fields:
        (tag, eltype, coltype)=self.fieldtypes[name]
        count=count-1
        tlb.nl()
        self._TRAPrepr_field(self.__dict__[name], eltype, coltype, name)
        if count: # not last element -> trailing comma
          tlb.append(",")
      tlb.dedent()
      # new line, closing brace, end comment
      tlb.nl()
      tlb.append(")  # "+self.__class__.__name__)
      tlb.nl()                    
      return
                          
  def _TRAPrepr_field(self, data, eltype, coltype, name=""): 
      # "print" one field of (any) IR object into output buffer
      # if 'name' is nonempty, prepend '<name> =', i.e. print a full Python assignment
      # if one-liner (elementary field): no newlines
      # if multi-liner (collection-typed field): comment & new line
      #                    after closing brace
      global _TRAP_lb
      tlb=_TRAP_lb
      BracDict={'{':'}', '[':']', '(':')', '':''}
      if name: # output Python named argument assignment syntax
        tlb.append(name+'= ')
      if isinstance(data, _TRAP_joker): # shortcut if field==joker
         tlb.append(data.name+' # joker')
         tlb.nl()
         return
      if data==None: 
         tlb.append('None'+' # undefined')
         tlb.nl()
         return
      if coltype=="":
         if eltype=='IntType' or eltype=='FloatType':
           tlb.append(str(data))
           return
         elif eltype=='StringType':
           tlb.append(_TRAP_quote(data))
           return
         elif eltype =="": #ANY
           tlb.append(repr(data)) # that's why __repr__ must be reentrant
           return
         else: # must be IR type - use class _TRAPrepr method
            # fetch method from class
            reprmeth=eval(eltype+"._TRAPrepr")
            reprmeth(data)
            return
      else: # collection-type field
         if coltype in ['[','(']: # list/tuple
            count=len(data)
            tlb.append(coltype) # opening sequence brace
            tlb.indent()
            if count<=1: # one-liner: empty or singleton sequence, no commas.
              if count==1: # one element
                self._TRAPrepr_field(data[0], eltype, "")
              tlb.dedent()  
              tlb.append(BracDict[coltype]) # closing sequence brace
              return
            # otherwise: multi-liner
            for d in data:
              tlb.nl()
              count=count-1
              self._TRAPrepr_field(d, eltype, "") # print seq element
              if count: # not last element -> comma
                tlb.append(",")
            tlb.dedent()
            tlb.nl()
            tlb.append(BracDict[coltype]+' # '+name) # closing bracket, comment
            tlb.nl()
         elif coltype=='{':
            print 'sorry, dictionaries as IR field types not implemented yet'

  def __xor__(self, partner): # generic pattern matching method (operator ^)
    # matching is defined as follows:
    # two node references match if the nodes they refer to are of the same node sort 
    # and all of their field values match, or if one of them is a joker.
    # Field values that are not node references match if they are equal (Python ==)
    # also, a node matches its node class and any domain class it is defined in
    if type(partner)==types.ClassType:
      return isinstance(self, partner)
    if isinstance(partner, _TRAP_joker):
      partner.match=self # bind match to joker
      return 1 # joker always matches
    if isinstance(self, _TRAP_joker):
      self.match=partner # bind match to joker
      return 1 # joker always matches
    # this method is only called for node references so the partner must be 
    # a node reference too, otherwise there can be no match
    if not isinstance (partner, REF): return 0 # partner no node ref at all - no match
    if self.__class__ != partner.__class__: return 0 # different node sorts - no match
    # at this point it's clear two nodes of the same sort are being matched
    ### print "self:", ; self.prt()
    for name in self.fields:
      ### print "field:", name
      (tag, eltype, coltype) = self.fieldtypes[name] # info valid for partner as well
      MFVal=self.__dict__[name]     # fetch own field value
      PFVal=partner.__dict__[name] # fetch partner field value
      if isinstance(PFVal, _TRAP_joker):
         PFVal.match=MFVal # bind match to joker
         ### print "partner joker" 
         continue # skip to next field
      if isinstance(MFVal, _TRAP_joker): 
         ### print "self joker"
         MFVal.match=PFVal # bind match to joker
         continue # skip to next field
      if tag==2: # collection-valued field
        length=len(MFVal)
        if  length != len(PFVal): 
           ### print "different lengths"
           return None # different lengths - no match
        match=1; i=0
        while match and i<length: # match elements, stop at first failure
          elMFVal=MFVal[i]; elPFVal=PFVal[i]; i=i+1
          if isinstance(elMFVal, REF): 
             match=elMFVal^elPFVal
          else:
             match=(elMFVal==elPFVal)
          ### if not match: print "failure at: #", i-1
        if not match: return None
      elif tag==1: # node-valued field
        if not MFVal^PFVal: 
          ### print "recursive match failed on field:", name
          return None
      else: # field of other Python type
        if MFVal != PFVal: 
          ### print "elementary match failed on field:", name
          return None
    ### print "match succeded"
    return 1 # success if we made it until here

  def Accept (self, Visitor, Context={}):
    # perform generic per-node operation encapsulated in visitor object
    # (GoF visitor pattern)
    # Visitor must be an instance of Visitor
    # call back Visitor.<nodetypename> method
    # REF.Accept should never be called, only the node classes' Accept's
    _TRAP_ERR("REF.Accept called")
# end class REF

class PartialVisitor:
  # abstract superclass for user-defined partial visitor classes.
  # ignores calls to nonexisting node visiting methods

  pass
  
class Visitor:
  # abstract superclass for complete user-defined visitor classes.
  # catches calls to nonexisting node visiting methods
  def nodefault(self, meth):
    _TRAP_ERR("Missing visitor method: "+self.__class__.__name__+"."+meth)






def Traverse(root, visitor, context={}):
  # traverse a tree or acyclic graph formed of TRAP nodes
  # all nodes have a "visited" attribute (initialized to 0)
  # do a depth-first traversal, mark nodes visited and
  # memoize them in nodes_visited (for fast cleanup)
  global nodes_visited
  nodes_visited=[]
  if not isinstance(root, REF):
    _TRAP_ERR("attempt to apply 'traverse' to non-node")
  traverse0(root, visitor, context)
  for n in nodes_visited:
    n.visited=0

def traverse0(node, visitor, context):
  global nodes_visited
  if node.visited: return
  # mark this node as visited
  node.visited=1
  nodes_visited.append(node)
  # visit subtrees
  for name in node.fields:
    (tag, eltype, coltype)=node.fieldtypes[name]
    child=node.__dict__[name]
    if tag==1: # node type
      ### print "recursing into:", child ###
      traverse0(child, visitor, context)
    elif tag==2: # collection
      if issubclass(eval(eltype), REF): # collection of nodes
        for c in child:
          traverse0(c, visitor, context)
      # no else: skip collections of non-nodes
    # no else: skip elemntary non-nodes
  # done with children, now for the node itself
  node.Accept(visitor, context)
      


# IR DOMAIN CLASSES ...

# IR NODE CLASSES ...

# JOKER CLASS FOR PATTERN CONSTRUCTION
TRAPjokerError='TRAPjokerError'
class _TRAP_joker:
    def __init__(self, name="_"): # joker objects have names
      self.name=name
      self.fields=[]
      self.fieldtypes={}
      self.clearbinding()
    def __getattr__(self, attr):
      if attr=='match': # match is stored in hidden attribute ___match really
        if self.name == '_':
          raise TRAPjokerError, 'cannot retrieve match value for generic joker _ - use qualified jokers _a-_z _A-_Z _0-_9 instead'
        else:
          if self.__dict__.has_key('___match'):
             return self.__dict__['___match']
          else:
             raise TRAPjokerError, 'attempt to access unbound joker variable: '+self.name
    def __setattr__(self, attr, value):
      if attr=='match': 
        if self.name != '_' and self.__dict__.has_key("match") and self.match: 
          raise TRAPjokerError, "match value assigned twice, joker variable: "+self.name
        else:
          self.__dict__['___match']=value
      else:
        self.__dict__[attr]=value

    def clearbinding(self):
      if self.__dict__.has_key('___match'): del self.__dict__['___match']
    def prt(self):
      global _TRAP_pr_ind
      print _TRAP_spaces(_TRAP_pr_ind)+self.name+' # joker'

# init global variables holding instances of the joker object
_0 = _TRAP_joker('_0')
_1 = _TRAP_joker('_1')
_2 = _TRAP_joker('_2')
_3 = _TRAP_joker('_3')
_4 = _TRAP_joker('_4')
_5 = _TRAP_joker('_5')
_6 = _TRAP_joker('_6')
_7 = _TRAP_joker('_7')
_8 = _TRAP_joker('_8')
_9 = _TRAP_joker('_9')
_a = _TRAP_joker('_a')
_b = _TRAP_joker('_b')
_c = _TRAP_joker('_c')
_d = _TRAP_joker('_d')
_e = _TRAP_joker('_e')
_f = _TRAP_joker('_f')
_g = _TRAP_joker('_g')
_h = _TRAP_joker('_h')
_i = _TRAP_joker('_i')
_j = _TRAP_joker('_j')
_k = _TRAP_joker('_k')
_l = _TRAP_joker('_l')
_m = _TRAP_joker('_m')
_n = _TRAP_joker('_n')
_o = _TRAP_joker('_o')
_p = _TRAP_joker('_p')
_q = _TRAP_joker('_q')
_r = _TRAP_joker('_r')
_s = _TRAP_joker('_s')
_t = _TRAP_joker('_t')
_u = _TRAP_joker('_u')
_v = _TRAP_joker('_v')
_w = _TRAP_joker('_w')
_x = _TRAP_joker('_x')
_y = _TRAP_joker('_y')
_z = _TRAP_joker('_z')
_A = _TRAP_joker('_A')
_B = _TRAP_joker('_B')
_C = _TRAP_joker('_C')
_D = _TRAP_joker('_D')
_E = _TRAP_joker('_E')
_F = _TRAP_joker('_F')
_G = _TRAP_joker('_G')
_H = _TRAP_joker('_H')
_I = _TRAP_joker('_I')
_J = _TRAP_joker('_J')
_K = _TRAP_joker('_K')
_L = _TRAP_joker('_L')
_M = _TRAP_joker('_M')
_N = _TRAP_joker('_N')
_O = _TRAP_joker('_O')
_P = _TRAP_joker('_P')
_Q = _TRAP_joker('_Q')
_R = _TRAP_joker('_R')
_S = _TRAP_joker('_S')
_T = _TRAP_joker('_T')
_U = _TRAP_joker('_U')
_V = _TRAP_joker('_V')
_W = _TRAP_joker('_W')
_X = _TRAP_joker('_X')
_Y = _TRAP_joker('_Y')
_Z = _TRAP_joker('_Z')
_ = _TRAP_joker('_')
joker_imports="""
from ctlCOMP import _0
from ctlCOMP import _1
from ctlCOMP import _2
from ctlCOMP import _3
from ctlCOMP import _4
from ctlCOMP import _5
from ctlCOMP import _6
from ctlCOMP import _7
from ctlCOMP import _8
from ctlCOMP import _9
from ctlCOMP import _a
from ctlCOMP import _b
from ctlCOMP import _c
from ctlCOMP import _d
from ctlCOMP import _e
from ctlCOMP import _f
from ctlCOMP import _g
from ctlCOMP import _h
from ctlCOMP import _i
from ctlCOMP import _j
from ctlCOMP import _k
from ctlCOMP import _l
from ctlCOMP import _m
from ctlCOMP import _n
from ctlCOMP import _o
from ctlCOMP import _p
from ctlCOMP import _q
from ctlCOMP import _r
from ctlCOMP import _s
from ctlCOMP import _t
from ctlCOMP import _u
from ctlCOMP import _v
from ctlCOMP import _w
from ctlCOMP import _x
from ctlCOMP import _y
from ctlCOMP import _z
from ctlCOMP import _A
from ctlCOMP import _B
from ctlCOMP import _C
from ctlCOMP import _D
from ctlCOMP import _E
from ctlCOMP import _F
from ctlCOMP import _G
from ctlCOMP import _H
from ctlCOMP import _I
from ctlCOMP import _J
from ctlCOMP import _K
from ctlCOMP import _L
from ctlCOMP import _M
from ctlCOMP import _N
from ctlCOMP import _O
from ctlCOMP import _P
from ctlCOMP import _Q
from ctlCOMP import _R
from ctlCOMP import _S
from ctlCOMP import _T
from ctlCOMP import _U
from ctlCOMP import _V
from ctlCOMP import _W
from ctlCOMP import _X
from ctlCOMP import _Y
from ctlCOMP import _Z
from ctlCOMP import _
"""
# PARSER/SEMANTICS BINDINGS 
_RGX_PREDICATE = '[a-z][A-Za-z0-9_]*'
def _S_PREDICATE(str):
  return str # automatic, default

def _DeclareTerminals(G):
  G.Addterm("_PREDICATE", _RGX_PREDICATE, _S_PREDICATE)
def _S_unary_1(list, Context):  #  >> "NOT"
  a = at3.createNewCTLUnary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  a.value.setValue((['NOT', 'AX', 'EX'], 0))
  a.graphObject_.ModifyAttribute("value", "NOT")
  TRAP_res=a
  _TRAP_typecheck("CTLUnary", "",  TRAP_res, 'Semantics value for nonterminal "unary"')
  return TRAP_res

def _S_unary_2(list, Context):  #  >> "AX"
  a = at3.createNewCTLUnary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100        
  a.value.setValue((['NOT', 'AX', 'EX'], 1))
  a.graphObject_.ModifyAttribute("value", "AX")
  TRAP_res=a
  _TRAP_typecheck("CTLUnary", "",  TRAP_res, 'Semantics value for nonterminal "unary"')
  return TRAP_res

def _S_unary_3(list, Context):  #  >> "EX"
  a = at3.createNewCTLUnary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  a.value.setValue((['NOT', 'AX', 'EX'], 2))
  a.graphObject_.ModifyAttribute("value", "EX")
  TRAP_res=a
  _TRAP_typecheck("CTLUnary", "",  TRAP_res, 'Semantics value for nonterminal "unary"')
  return TRAP_res

def _S_binary_1(list, Context):  #  >> "AND"
  a = at3.createNewCTLBinary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  at3.ctlpx+=100
  a.value.setValue((['AND', 'AU', 'EU'], 0))
  a.graphObject_.ModifyAttribute("value", "AND")
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "binary"')
  return TRAP_res

def _S_binary_2(list, Context):  #  >> "AU"
  a = at3.createNewCTLBinary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  at3.ctlpx+=100
  a.value.setValue((['AND', 'AU', 'EU'], 1))
  a.graphObject_.ModifyAttribute("value", "AU")
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "binary"')
  return TRAP_res

def _S_binary_3(list, Context):  #  >> "EU"
  a = at3.createNewCTLBinary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  at3.ctlpx+=100
  a.value.setValue((['AND', 'AU', 'EU'], 2))
  a.graphObject_.ModifyAttribute("value", "EU")
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "binary"')
  return TRAP_res

def _S_rest_1(list, Context):  #  >> pformula=ROper
  ROper=list[1]
  Bin=list[0]
  a = at3.createNewCTLBinaryOperRight(at3, at3.ctlpx, at3.ctlpy)
  at3.drawConnections((Bin, a), (a, ROper))
  at3.level = at3.level - 1
  TRAP_res=Bin
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "rest"')
  return TRAP_res

def _S_rest_2(list, Context):  #  >> pformula=ROper
  a = None
  at3.ctlpy+=100
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "rest"')
  return TRAP_res

def _S_pformula_1(list, Context):  #  >> rest=Bin
  Pred=list[0]
  Bin=list[1]
  at3.level = at3.level+1
  at3.ctlpx-=100
  pr = at3.createNewCTLPredicate(at3, at3.ctlpx, at3.ctlpy)
  print "creating predicate ", Pred, "at :", at3.ctlpx, at3.ctlpy, "level = ", at3.level
  pr.value.setValue(Pred)
  pr.graphObject_.ModifyAttribute("value", Pred)
  aux = pr
  if Bin:
     a = at3.createNewCTLBinaryOperLeft(at3, at3.ctlpx, at3.ctlpy)
     at3.drawConnections((Bin, a), (a, pr))
  TRAP_res=aux
  _TRAP_typecheck("ASGNode", "",  TRAP_res, 'Semantics value for nonterminal "pformula"')
  return TRAP_res

def _S_pformula_2(list, Context):  #  >> pformula=Sfor
  Sfor=list[1]
  UnOp=list[0]
  aux = UnOp
  a = at3.createNewCTLUnaryOper(at3, at3.ctlpx, at3.ctlpy)
  at3.drawConnections((UnOp, a), (a, Sfor))
  TRAP_res=aux
  _TRAP_typecheck("ASGNode", "",  TRAP_res, 'Semantics value for nonterminal "pformula"')
  return TRAP_res

def _BindRules(G):
  G.Bind( "_unary_1", _S_unary_1 )
  G.Bind( "_unary_2", _S_unary_2 )
  G.Bind( "_unary_3", _S_unary_3 )
  G.Bind( "_binary_1", _S_binary_1 )
  G.Bind( "_binary_2", _S_binary_2 )
  G.Bind( "_binary_3", _S_binary_3 )
  G.Bind( "_rest_1", _S_rest_1 )
  G.Bind( "_rest_2", _S_rest_2 )
  G.Bind( "_pformula_1", _S_pformula_1 )
  G.Bind( "_pformula_2", _S_pformula_2 )


def _TRAP_ERR (str=""):
    import sys
    sys.stdout=sys.__stdout__
    msg=""
    if str: msg=": "+str
    print("COMPILER ERROR"+msg)
    sys.exit(1)

import sys
for spath in ['../', '../ATOM3Types', '../TypeModels', '../GraphGrammar', '../UserInterface', '../ERModels', '../ButtonsModels']:
  if not spath in sys.path: sys.path.append(spath)
from ATOM3         import ATOM3
from Tkinter       import *
from CTLPredicate  import CTLPredicate
from CTLUnary      import CTLUnary
from CTLBinary     import CTLBinary
from ASG_CTL import ASG_CTL
from ASGNode import ASGNode 
at3 =  ATOM3( Tk(), "CTL" , 1, 1)
at3.ctlpx, at3.ctlpy = 150, 150             # coordinates of the last drawn node
at3.level = 0

import kjParser
def _TRAP_unMarshalG(): # unpack generated parser - w/o LINOLEX
    infile = open('ctlGG.mar', 'rb') 
    GenG = kjParser.UnMarshalGram(infile)
    infile.close()
    _DeclareTerminals(GenG)
    _BindRules(GenG)
    return GenG


class Compiler:
  def __init__(self): # init parser, load marshalled parser table
    self.kjGram = _TRAP_unMarshalG()

  def CompileString(self, String, Context={}):
      return self.kjGram.DoParse(String, Context)

  def CompileFile(self, filename, Context={}):
      inp=open(filename, "r")
      istr = inp.read()
      inp.close()
      return self.CompileString(istr, Context)
      
def CompileCommandline():
  ifile=sys.argv[1]
  C=Compiler()
  print "Processing File", ifile, "..."
  print C.CompileFile(ifile)[0]

# MAIN BLOCK
# if command line argument, construct compiler and invoke it on that
import sys
if __name__ == "__main__":
  # print "do it in COMP"
  if len(sys.argv)>1: 
    CompileCommandline()
  else:
    print "missing input file name"


