from graphEntity     import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_ERrelationship_Center(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 96, 92
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_polygon(self.translate([3.0, 48.0, 48.0, 3.0, 93.0, 48.0, 48.0, 90.0]), tags = self.tag, fill = "lightyellow", outline="black")
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_oval(self.translate([3.0, 48.0, 3.0, 48.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([48.0, 3.0, 48.0, 3.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([93.0, 48.0, 93.0, 48.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([46.0, 88.0, 46.0, 88.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.name.toString(25,5)
        else: drawText = "<name>"
        h = drawing.create_text(self.translate([46.0, 45.0]), tags = self.tag, text = drawText, fill = "blue")

        self.attr_display["name"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_ERrelationship_Center
