
# Author: Ernesto Posse
# Date:   June 4, 2002
# Description: This is a list of typical access methods for python
#   constraints or actions in AToM3 models and graph-grammars.


# To access the instance of ATOM3 in an entity's constraint
# where self is the instance of the entity:

atom3i = self.parent

# To access to the root node of the ASG in an entity's constraint
# where self is the instance of the entity:

atom3i = self.parent
root = atom3i.ASGroot

# Global constraint's are attributes of the root node, so to get the
# value of a global attribute 'gattr', in an entity's constraint do:

val = self.parent.ASGroot.gattr.getValue()

# To access a semantic object in an appearence constraint:

obj = self.semanticObject

# To access some semantic object obj's graphical instance:

gobj = obj.graphObject_

# This inherits from graphEntity which inherits from VisualObj
# Its bounding box is obtained by

bb = gobj.dc.bbox(gobj.tag)

# Doing this on an appearance's constraint:

bb = self.dc.bbox(self.tag)

